;----------------------------------------------------------------
;	X68k High-speed Assembler
;		_Z
;		< fexpr.s >
;
;	$Id: fexpr.s,v 1.8  1999 10/ 6(Wed) 14:54:26 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;		          1997-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	_vZ
;	in :a0 = R[hw|C^ / (CMDOPSIZE) = ʂ̃TCY
;	out:d0:d1:d2 = 
calcfexpr::
	movem.l	d3-d7/a1,-(sp)
	bsr	calcfex_xoror		;̒l𓾂(gxŌvZ)
	pea.l	(calcfexpr9,pc)
	move.b	(CMDOPSIZE,a6),d7	;ʂKvȐxɕϊ
	cmpi.b	#SZ_SHORT,d7
	beq	xtos
	cmpi.b	#SZ_DOUBLE,d7
	beq	xtod
	cmpi.b	#SZ_PACKED,d7
	beq	xtop
	addq.l	#4,sp
	swap.w	d0			;(SZ_EXTEND)
	clr.w	d0
calcfexpr9:
	movem.l	(sp)+,d3-d7/a1
	rts

;----------------------------------------------------------------
calcfex_xoror:				;xor/or
	bsr	calcfex_and
calcfex_xoror1:
	move.w	(a0),d7
	move.w	#OP_XOR|OT_OPERATOR,d6
	cmp.w	d6,d7
	beq	calcfex_xoror3
	cmp.w	#'^'|OT_CHAR,d7
	beq	calcfex_xoror3
	move.w	#OP_OR|OT_OPERATOR,d6
	cmp.w	d6,d7
	beq	calcfex_xoror3
	cmp.w	#'|'|OT_CHAR,d7
	beq	calcfex_xoror3
	rts

calcfex_xoror3:
	lea.l	(calcfex_and,pc),a1
	bsr	calcfex_intop2
	bra	calcfex_xoror1

;----------------------------------------------------------------
calcfex_and:				;and
	bsr	calcfex_cmp
calcfex_and1:
	move.w	(a0),d7
	move.w	#OP_AND|OT_OPERATOR,d6
	cmp.w	d6,d7
	beq	calcfex_and3
	cmp.w	#'&'|OT_CHAR,d7
	beq	calcfex_and3
	rts

calcfex_and3:
	lea.l	(calcfex_cmp,pc),a1
	bsr	calcfex_intop2
	bra	calcfex_and1

;----------------------------------------------------------------
calcfex_cmp:				;r
	bsr	calcfex_addsub
calcfex_cmp1:
	move.l	(a0),d6
	swap.w	d6
	move.w	d6,d7
	clr.b	d7			;and.w #$FF00,d7
	cmp.w	#OT_OPERATOR,d7
	bne	calcfex_cmp11
	cmp.b	#OP_EQ,d6
	blo	calcfex_cmp10
	cmp.b	#OP_SGE,d6
	bls	calcfex_cmp2
calcfex_cmp10:
	rts

calcfex_cmp11:
	move.l	d6,d7
	moveq.l	#OP_EQ,d6
	cmp.l	#('='|OT_CHAR)+(('='|OT_CHAR)<<16),d7
	beq	calcfex_cmp22
	cmp.w	#'='|OT_CHAR,d7
	beq	calcfex_cmp2
	moveq.l	#OP_NE,d6
	cmp.l	#('<'|OT_CHAR)+(('>'|OT_CHAR)<<16),d7
	beq	calcfex_cmp22
	cmp.l	#('!'|OT_CHAR)+(('='|OT_CHAR)<<16),d7
	beq	calcfex_cmp22
	moveq.l	#OP_LE,d6
	cmp.l	#('<'|OT_CHAR)+(('='|OT_CHAR)<<16),d7
	beq	calcfex_cmp22
	moveq.l	#OP_GE,d6
	cmp.l	#('>'|OT_CHAR)+(('='|OT_CHAR)<<16),d7
	beq	calcfex_cmp22
	moveq.l	#OP_LT,d6
	cmp.w	#'<'|OT_CHAR,d7
	beq	calcfex_cmp2
	moveq.l	#OP_GT,d6
	cmp.w	#'>'|OT_CHAR,d7
	beq	calcfex_cmp2
	rts

calcfex_cmp22:
	addq.l	#2,a0
calcfex_cmp2:
	lea.l	(calcfex_addsub,pc),a1
	bsr	calcfex_op2
	bra	calcfex_cmp1

;----------------------------------------------------------------
calcfex_addsub:				;Z
	bsr	calcfex_muldiv
calcfex_addsub1:
	move.w	(a0),d7
	moveq.l	#OP_ADD,d6
	cmp.w	#'+'|OT_CHAR,d7
	beq	calcfex_addsub2
	moveq.l	#OP_SUB,d6
	cmp.w	#'-'|OT_CHAR,d7
	beq	calcfex_addsub2
	rts

calcfex_addsub2:
	lea.l	(calcfex_muldiv,pc),a1
	bsr	calcfex_op2
	bra	calcfex_addsub1

;----------------------------------------------------------------
calcfex_muldiv:				;揜Z
	bsr	calcfex_unary
calcfex_muldiv1:
	move.l	(a0),d6
	swap.w	d6
	move.w	d6,d7
	clr.b	d7			;and.w #$FF00,d7
	cmp.w	#OT_OPERATOR,d7
	bne	calcfex_muldiv11
.if 0
	cmp.b	#OP_MOD,d6
.else
	cmp.b	#OP_SHR,d6
.endif
	blo	calcfex_muldiv10
	cmp.b	#OP_ASR,d6
	bls	calcfex_muldiv3
calcfex_muldiv10:
	rts

calcfex_muldiv11:
	move.l	d6,d7
	moveq.l	#OP_MUL,d6
	cmp.w	#'*'|OT_CHAR,d7
	beq	calcfex_muldiv2
	moveq.l	#OP_DIV,d6
	cmp.w	#'/'|OT_CHAR,d7
	beq	calcfex_muldiv2
	moveq.l	#OP_SHR,d6
	cmp.l	#('>'|OT_CHAR)+(('>'|OT_CHAR)<<16),d7
	beq	calcfex_muldiv32
	moveq.l	#OP_SHL,d6
	cmp.l	#('<'|OT_CHAR)+(('<'|OT_CHAR)<<16),d7
	beq	calcfex_muldiv32
	rts

calcfex_muldiv22:
	addq.l	#2,a0
calcfex_muldiv2:
	lea.l	(calcfex_unary,pc),a1
	bsr	calcfex_op2
	bra	calcfex_muldiv1

calcfex_muldiv32:
	addq.l	#2,a0
calcfex_muldiv3:
	lea.l	(calcfex_unary,pc),a1
	bsr	calcfex_intop2
	bra	calcfex_muldiv1

;----------------------------------------------------------------
calcfex_unary:				;P
	move.w	(a0),d7
	cmp.w	#'-'|OT_CHAR,d7
	beq	calcfex_neg
	cmp.w	#'+'|OT_CHAR,d7
	beq	calcfex_prime0
	move.b	d7,d6
	clr.b	d7			;and.w #$FF00,d7
	cmp.w	#OT_OPERATOR,d7
	bne	calcfex_prime
	cmp.b	#OP_NOT,d6
	blo	calcfex_prime
	cmp.b	#OP_NUL,d6
	bls	calcfex_unary_intop1
	cmp.b	#OP_NOTB,d6
	blo	calcfex_prime
calcfex_unary_intop1:
	lea.l	(calcfex_prime,pc),a1
	bra	calcfex_intop1

calcfex_neg:
	pea.l	(xneg,pc)
;	bra	calcfex_prime0
;----------------------------------------------------------------
calcfex_prime0:
	addq.l	#2,a0
calcfex_prime:				;ꎟ
	move.w	(a0)+,d6
	cmp.w	#'('|OT_CHAR,d6
	beq	calcfex_paren
	move.w	d6,d7
	clr.b	d6			;and.w #$FF00,d6
	sub.w	d6,d7			;and.w #$00FF,d7
	cmp.w	#OT_REAL,d6
	beq	calcfex_real
	cmp.w	#OT_VALUEB,d6
	beq	calcfex_valueb
	cmp.w	#OT_VALUEW,d6
	beq	calcfex_valuew
	cmp.w	#OT_VALUE,d6
	beq	calcfex_value
	cmp.w	#OT_VALUEQ,d6
	beq	calcfex_valueq
	cmp.w	#OT_SYMBOL,d6
	beq	calcfex_symbol
	cmp.w	#OT_STR,d6
	bne	exprerr			;łȂ΃G[
	tst.w	d7
	beq	exprerr			;kXgOG[
	cmp.w	#4,d7
	bhi	exprerr			;4ȏとG[
	subq.w	#1,d7
	moveq.l	#0,d0			;
calcfex_str:
	asl.l	#8,d0
	move.b	(a0)+,d0
	dbra	d7,calcfex_str
	move.l	a0,d1
	doeven	d1
	movea.l	d1,a0
	bsr	ltox
	bra	calcfex_size

calcfex_real:				;_l
	move.w	(a0)+,d0
	move.l	(a0)+,d1
	move.l	(a0)+,d2
	bra	calcfex_size

calcfex_valueq:
	move.l	(a0)+,d1		;32bit
	move.l	(a0)+,d0		;32bit
	bsr	qtox
	bra	calcfex_size

calcfex_value:				;l
	move.l	(a0)+,d0
	bsr	ltox
	bra	calcfex_size

calcfex_valuew:
	moveq.l	#0,d0
	move.w	(a0)+,d0
	bsr	ltox
	bra	calcfex_size

calcfex_valueb:
	moveq.l	#0,d0
	move.b	d7,d0
	bsr	ltox
	bra	calcfex_size

calcfex_symbol:				;V{
	movea.l	(a0)+,a1
	cmpi.b	#ST_REAL,(SYM_TYPE,a1)	;_V{
	beq	calcfex_symreal
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a1)	;(ST_VALUE or ST_LOCAL)
	bhi	exprerr
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	blo	exprerr			;l܂ĂȂ
	tst.b	(SYM_SECTION,a1)	;(cmpi.b #SECT_ABS,(SYM_SECTION,a1))
	bne	exprerr			;萔łȂ
	move.l	(SYM_VALUE,a1),d0
	bsr	ltox
	bra	calcfex_size

calcfex_symreal:
	move.b	(SYM_FSIZE,a1),d7	;V{̃TCY
	bmi	calcfex_symreal01	;V{`ĂȂ
	move.l	(SYM_FVPTR,a1),a1	;V{lւ̃|C^
	movem.l	(a1),d0-d2		;V{l𓾂
	subq.b	#SZ_SINGLE,d7
	beq	calcfex_symreal_single
	subq.b	#SZ_DOUBLE-SZ_SINGLE,d7
	beq	calcfex_symreal_double
	subq.b	#SZ_PACKED-SZ_DOUBLE,d7
	beq	calcfex_symreal_packed
	swap.w	d0
	bsr	normalize
	bra	calcfex_size

calcfex_symreal01:
;ł(SYM_TYPE,a1)=ST_REALȂ̂Ń[JV{͍lȂĂ悢
	move.l	a1,(ERRMESSYM,a6)
	bra	undefsymerr

calcfex_symreal_single:
	bsr	stox
	bra	calcfex_size

calcfex_symreal_double:
	bsr	dtox
	bra	calcfex_size

calcfex_symreal_packed:
	bsr	ptox
	bra	calcfex_size

calcfex_paren:
	bsr	calcfex_xoror
	cmpi.w	#')'|OT_CHAR,(a0)+
	bne	exprerr			;ʂĂȂ
;TCYw
calcfex_size:
	cmpi.b	#OT_SIZE>>8,(a0)
	beq	calcfex_size_0		;TCYw肠
calcfex_size_extend:			;Ȃ
	rts

calcfex_size_0:
	move.w	(a0)+,d6
	subq.b	#SZ_WORD,d6
	bcs	calcfex_size_byte
	beq	calcfex_size_word
	subq.b	#SZ_SHORT-SZ_WORD,d6
	bcs	calcfex_size_long
;	beq	calcfex_size_single
	subq.b	#SZ_DOUBLE-SZ_SHORT,d6
	bcs	calcfex_size_single
	beq	calcfex_size_double
	subq.b	#SZ_PACKED-SZ_DOUBLE,d6
	bcs	calcfex_size_extend
	beq	calcfex_size_packed
;.q̏
calcfex_size_quad:
	bsr	calcfex_size_int
	cmp.w	#63,d6
	bgt	overflowerr		;Βl2^64ȏ
	beq	calcfex_size_int_max
	rts

;.l̏
calcfex_size_long:
	bsr	calcfex_size_int
	cmp.w	#31,d6
	bgt	overflowerr		;Βl2^32ȏ
	beq	calcfex_size_int_max
	rts

;.w̏
calcfex_size_word:
	bsr	calcfex_size_int
	cmp.w	#15,d6
	bgt	overflowerr		;Βl2^16ȏ
	beq	calcfex_size_int_max
	rts

;.b̏
calcfex_size_byte:
	bsr	calcfex_size_int
	cmp.w	#7,d6
	bgt	overflowerr		;Βl2^8ȏ
	beq	calcfex_size_int_max
	rts

calcfex_size_int_max:
	tst.w	d0
	bpl	overflowerr		;2^63ȏ
	tst.l	d2
	bne	overflowerr		;-2^63
	cmp.l	#$80000000,d1
	bne	overflowerr		;-2^63
	rts

;Ɋۂ߂
;	A_[t[0
;	INFNAN̓G[
;<d0.w:d1.l:d2.l:gx_
;>d6.w:w(x[X0,͊̕܂܂)
calcfex_size_int:
	move.w	d0,d6
	and.w	#$7FFF,d6
	sub.w	#$3FFF,d6		;_̈ʒu
	bsr	calcfex_rn		;Ɋۂ߂
	move.w	d0,d6			;ۂ߂̎weXgȂ΂ȂȂ
					;(ۂ߂1ɂȂ萮͈͓ɂ肬
					;؂鐔)
	and.w	#$7FFF,d6
	cmp.w	#$7FFF,d6
	beq	calcfex_size_int_error	;INFNAN
	sub.w	#$3FFF,d6
	bpl	calcfex_size_int_done	;Βl1ȏ(̓`FbNȂ)
	addq.l	#4,sp			;calcfex_size_{quad/long/word/byte}甲
	and.w	#$8000,d0		;A_[t[(񐳋K܂)
	moveq.l	#0,d1
	moveq.l	#0,d2
calcfex_size_int_done:
	rts

calcfex_size_int_error:
	tst.l	d1
	bne	ilvalueerr		;NAN͐łȂ
	tst.l	d2
	bne	ilvalueerr		;NAN͐łȂ
	bra	overflowerr		;INFȂI[o[t[

;.d̏
calcfex_size_double:
	moveq.l	#52,d6			;_ȉ52rbg܂(53rbgڂ01)
	move.w	d0,d7
	and.w	#$7FFF,d7
	sub.w	#$3FFF-$3FE,d7
	bpl	calcfex_size_double_0
	add.w	d7,d6			;񐳋K̏ꍇ̓rbg炷
					;񐳋KȉȂΕw肳
calcfex_size_double_0:
	bsr	calcfex_rn
	move.w	d0,d6
	and.w	#$7FFF,d6
	cmp.w	#$3FFF+$3FF,d6
	bhi	calcfex_size_real_inf
	rts				;񐳋Kȉcalcfex_rn0ɂȂĂ,
					;01Ŏw邱Ƃ͂Ȃ̂,
					;ł̓A_[t[0`FbNȂĂ悢

;.s̏
calcfex_size_single:
	moveq.l	#23,d6			;_ȉ23rbg܂(24rbgڂ01)
	move.w	d0,d7
	and.w	#$7FFF,d7
	sub.w	#$3FFF-$7E,d7
	bpl	calcfex_size_single_0
	add.w	d7,d6			;񐳋K̏ꍇ̓rbg炷
					;񐳋KȉȂΕw肳
calcfex_size_single_0:
	bsr	calcfex_rn
	move.w	d0,d6
	and.w	#$7FFF,d6
	cmp.w	#$3FFF+$7F,d6
	bhi	calcfex_size_real_inf
	rts				;񐳋Kȉcalcfex_rn0ɂȂĂ,
					;01Ŏw邱Ƃ͂Ȃ̂,
					;ł̓A_[t[0`FbNȂĂ悢

;doublesingleւ̕ϊŃI[o[t[Ƃ
;G[͏oȂ
calcfex_size_real_inf:
	or.w	#$7FFF,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	rts

;.p̏
calcfex_size_packed:
	bsr	xtop
	bra	ptox

;gxRounding NearestŊۂ߂
;<d0.w:d1.l:d2.l:gx
;<d6.w:̏_ȉrbĝƂŊۂ߂邩
;	-1  0  1  2  28 29 30 31  32  33  34  60 61 62  d6.w
;	  31 30 29 c  2  1  0  31  30  29  c  2  1  0
;	 |         d1         ||            d2         |
;	ȂΏ_̈ʒu
;	̈ʒủE獶01
;	̈ʒủE1000ĉƂ͍̈ʂ0ɂȂ悤Ɋۂ߂
;>d0.w:d1.l:d2.l:
;?d6.l/d7.l
calcfex_rn::
	cmp.w	#$7FFF,d0
	bge	calcfex_rn_done		;INFNAN͂̂܂
	cmp.w	#$FFFF,d0
	bcc	calcfex_rn_done		;INFNAN͂̂܂
	cmp.w	#-1,d6			;w-1ł1ɌJオ邱Ƃ
	blt	calcfex_rn_zero		;d1ׂ0.25ȉ(񐳋K܂)
	moveq.l	#30,d7
	sub.w	d6,d7
;d7=0.5̃rbg(0`31)
;	31  30  29  28  2 1 0 -1  -2  -3  -4  -30 -31 -32  d7.w
;	  31  30  29  c 2 1 0  31  30  29  c   2   1   0
;	 |            d1      ||            d2            |
	bmi	calcfex_rn_1		;0.5̃rbgd2ɂ
;0.5̃rbgd1ɂ
;d7=0.5̃rbg(0`31)
	moveq.l	#0,d6
	bset.l	d7,d6			;0.5̃rbg(0`31)
;d6=0.5̃rbgZbg
	btst.l	d7,d1			;0.5̃rbgeXg
	bne	calcfex_rn_2		;0.5̃rbgĂ
;0.5̃rbgd1ɂ0.5̃rbgĂȂ̂Ő؂̂Ă
;d6=0.5̃rbgZbg
	moveq.l	#0,d2
;0.5̃rbgd1ɂ菬0.51̃rbg0Ȃ̂Ő؂̂Ă
;JグȂ
;d2=0
;d6=0.5̃rbgZbg
calcfex_rn_5:
	neg.l	d6			;0.5ȏ̃}XN
	add.l	d6,d6			;1ȏ̃}XN(0̂Ƃ)
	beq	calcfex_rn_zero
	and.l	d6,d1
calcfex_rn_done:
	rts

;0.5̃rbgd2ɂ
;d7=0.5̃rbg(0`31)
;	-1  -2  -3  -4  -30 -31 -32  d7.w
;	  31  30  29  c   2   1   0
;	 |            d2            |
calcfex_rn_1:
	add.w	#32,d7
;d7=0.5̃rbg(0`31)
;	31  30  29  28  2  1 0  d7.w
;	  31  30  29  c  2 1 0
;	 |            d2       |
	bmi	calcfex_rn_done		;0.5̃rbgd2Eɂ̂ŉȂ
;d7=0.5̃rbg(0`31)
	moveq.l	#0,d6
	bset.l	d7,d6			;0.5̃rbgZbg
;d6=0.5̃rbgZbg
	btst.l	d7,d2			;0.5̃rbgeXg
	bne	calcfex_rn_12		;0.5̃rbgĂ
;0.5̃rbgd2ɂ0.5̃rbgĂȂ̂Ő؂̂Ă
;d6=0.5̃rbgZbg
calcfex_rn_15:
	neg.l	d6			;0.5ȏ̃}XN
	add.l	d6,d6			;1ȏ̃}XN(0̂Ƃ)
	and.l	d6,d2
	rts

;0܂̓A_[t[
calcfex_rn_zero:
	and.w	#$8000,d0		;c
	moveq.l	#0,d1
	moveq.l	#0,d2
	rts

;0.5̃rbgd1ɂ0.5̃rbgĂ
;d6=0.5̃rbgZbg
;d7=0.5̃rbg(0`31)
calcfex_rn_2:
	tst.l	d2
	bne	calcfex_rn_3		;0.5ł͂Ȃ̂ŌJグ
;d2=0
	subq.l	#1,d6			;0.25ȉ̃}XN
	and.l	d1,d6			;0.25ȉ̃rbgĂ邩
	bne	calcfex_rn_7		;0.5ł͂Ȃ̂ŌJグ
;0.5̃rbgd1ɂ菬0.5Ȃ̂0.5̊ۂ߂s
	moveq.l	#0,d6
	bset.l	d7,d6			;0.5̃rbgZbg
;d6=0.5̃rbgZbg
	addq.b	#1,d7			;1̃rbg(1`32)
;d7=1̃rbg(0`31)
	cmp.b	#32,d7
	beq	calcfex_rn_zero		;1̃rbgȂ̂Ő؂̂Ă0ɂȂ
	btst.l	d7,d1			;1̃rbgeXg
	bne	calcfex_rn_4		;1̃rbg1Ȃ̂ŌJグ
;0.5̃rbgd1ɂ菬0.51̃rbg0Ȃ̂Ő؂̂Ă
	bra	calcfex_rn_5

;0.5̃rbgd2ɂ菬0.51̃rbgd1ɂ
;d7=32
calcfex_rn_18:
	btst.l	d7,d1			;1̃rbgeXg
	bne	calcfex_rn_16		;1̃rbg1Ȃ̂ŌJグ
;0.5̃rbgd2ɂ菬0.51̃rbgd1ɂ1̃rbg0Ȃ̂Ő؂̂Ă
	moveq.l	#0,d2
	rts

;0.5̃rbgd2ɂ0.5̃rbgĂ
;d6=0.5̃rbgZbg
;d7=0.5̃rbg(0`31)
calcfex_rn_12:
	subq.l	#1,d6			;0.25ȉ̃}XN
	and.l	d2,d6			;0.25ȉ̃rbgĂ邩
	bne	calcfex_rn_17		;0.5ł͂Ȃ̂ŌJグ
;0.5̃rbgd2ɂ菬0.5Ȃ̂0.5̊ۂ߂s
	moveq.l	#0,d6
	bset.l	d7,d6			;0.5̃rbgZbg
;d6=0.5̃rbgZbg
	addq.b	#1,d7			;1̃rbg(1`32)
;d7=1̃rbg(1`32)
	cmp.b	#32,d7
	beq	calcfex_rn_18		;1̃rbgd1ɂ
	btst.l	d7,d2			;1̃rbgeXg
	bne	calcfex_rn_14		;1̃rbg1Ȃ̂ŌJグ
	bra	calcfex_rn_15

;0.5̃rbgd2ɂ0.5̃rbgĂ邪0.5ł͂Ȃ̂ŌJグ
calcfex_rn_17:
	moveq.l	#0,d6
	bset.l	d7,d6			;0.5̃rbgZbg
;0.5̃rbgd2ɂ菬0.51̃rbgĂ̂ŌJグ
;d6=0.5̃rbgZbg
calcfex_rn_14:
	add.l	d6,d2			;Jグ
	bcc	calcfex_rn_15
;0.5̃rbgd2ɂJグd2ꂽ
;0.5̃rbgd2ɂ菬0.51̃rbgd1ɂ1̃rbgĂ̂ŌJグ
calcfex_rn_16:
	moveq.l	#1,d6
;0.5̃rbgd1ɂ0.5̃rbgĂ邪0.5ł͂Ȃ̂ŌJグ
;d6=0.5̃rbgZbg
calcfex_rn_3:
	moveq.l	#0,d2
	bra	calcfex_rn_4

;0.5̃rbgd1ɂ0.5̃rbgĂ邪0.5ł͂Ȃ̂ŌJグ
;d2=0
;d7=0.5̃rbg(0`31)
calcfex_rn_7:
	moveq.l	#0,d6
	bset.l	d7,d6			;0.5̃rbgZbg
;0.5̃rbgd1ɂ菬0.51̃rbg1Ȃ̂ŌJグ
;d2=0
;d6=0.5̃rbgZbg
calcfex_rn_4:
	add.l	d6,d1			;Jグ
	bcc	calcfex_rn_5		;Ȃ
;0.5̃rbgd1ɂJグ牼ꂽ
;d2=0
	addq.w	#1,d0			;INFNAN͍ŏɏĂ̂,
					;w邱Ƃ͂Ȃ
	cmp.w	#$7FFF,d0
	beq	calcfex_rn_overflow	;I[o[t[
	cmp.w	#$FFFF,d0
	beq	calcfex_rn_overflow	;I[o[t[
	moveq.l	#1,d1			;%1000cɂȂ
	ror.l	#1,d1
	rts

;I[o[t[
;d0=$7FFF܂$FFFF
;d2=0
calcfex_rn_overflow:
	moveq.l	#0,d1
	rts

;----------------------------------------------------------------
;PZ
;<d6.b:Zqԍ
;<a1.l:Zq̉E̎vZ郋[`̃AhX
calcfex_intop1:
	addq.l	#2,a0
	move.b	d6,-(sp)
	jsr	(a1)
	bsr	xtol_overflow_check
	bra	calcfex_intop0

;񍀐Z
;<d6.b:Zqԍ
;<a1.l:Zq̉E̎vZ郋[`̃AhX
calcfex_intop2:
	addq.l	#2,a0
	bsr	xtol_overflow_check
	move.b	d6,-(sp)
	move.l	d0,-(sp)		;≉Z
	jsr	(a1)
	bsr	xtol_overflow_check
	move.l	d0,d1			;Z
	move.l	(sp)+,d0
calcfex_intop0:
	clr.w	d6
	move.b	(sp)+,d6
	bsr	calcfex_opjmp
	bra	ltox

xtol_overflow_check:
	bsr	xtol
	tst.w	d1
	bmi	overflowerr
	rts

;񍀉Z
;<d6.b:Zqԍ
;<a1.l:Zq̉E̎vZ郋[`̃AhX
calcfex_op2:
	addq.l	#2,a0
	move.b	d6,-(sp)
	movem.l	d0-d2,-(sp)
	jsr	(a1)
	move.l	d0,d3
	move.l	d1,d4
	move.l	d2,d5
	movem.l	(sp)+,d0-d2
	clr.w	d6
	move.b	(sp)+,d6
calcfex_opjmp:
	add.w	d6,d6			;Zqԍ*2
	move.w	(fexjp_tbl-2*OP_NOT,pc,d6.w),d6
	jmp	(fexjp_tbl,pc,d6.w)

fexjp_tbl:
	.dc.w	fex_not-fexjp_tbl	;.not.
	.dc.w	fex_high-fexjp_tbl	;.high.
	.dc.w	fex_low-fexjp_tbl	;.low.
	.dc.w	fex_highw-fexjp_tbl	;.highw.
	.dc.w	fex_loww-fexjp_tbl	;.loww.
	.dc.w	fex_nul-fexjp_tbl	;.nul.
	.dc.w	xmul-fexjp_tbl		;*	(񍀉Zq)
	.dc.w	xdiv-fexjp_tbl		;/
	.dc.w	-1			;.mod.
	.dc.w	fex_shr-fexjp_tbl	;.shr.(>>)
	.dc.w	fex_shl-fexjp_tbl	;.shl.(<<)
	.dc.w	fex_asr-fexjp_tbl	;.asr.
	.dc.w	xsub-fexjp_tbl		;-
	.dc.w	xadd-fexjp_tbl		;+
	.dc.w	fex_eq-fexjp_tbl	;.eq.(=,==)
	.dc.w	fex_ne-fexjp_tbl	;.ne.(<>,!=)
	.dc.w	fex_lt-fexjp_tbl	;.lt.(<)
	.dc.w	fex_le-fexjp_tbl	;.le.(<=)
	.dc.w	fex_gt-fexjp_tbl	;.gt.(>)
	.dc.w	fex_ge-fexjp_tbl	;.ge.(>=)
	.dc.w	fex_lt-fexjp_tbl	;.slt.
	.dc.w	fex_le-fexjp_tbl	;.sle.
	.dc.w	fex_gt-fexjp_tbl	;.sgt.
	.dc.w	fex_ge-fexjp_tbl	;.sge.
	.dc.w	fex_and-fexjp_tbl	;.and.(&)
	.dc.w	fex_xor-fexjp_tbl	;.xor.(^)
	.dc.w	fex_or-fexjp_tbl	;.or.(|)
	.dc.w	fex_notb-fexjp_tbl	;.notb.
	.dc.w	fex_notw-fexjp_tbl	;.notw.

fex_not:
	not.l	d0
	rts

fex_notb:
	not.b	d0
	bra	fex_low

fex_high:
	lsr.l	#8,d0
fex_low:
	and.l	#$000000FF,d0
	rts

fex_notw:
	not.w	d0
fex_loww:
	swap.w	d0
fex_highw:
	clr.w	d0
	swap.w	d0
	rts

fex_nul:
	moveq.l	#0,d0
	rts

fex_shr:
	lsr.l	d1,d0
	rts

fex_shl:
	lsl.l	d1,d0
	rts

fex_asr:
	asr.l	d1,d0
	rts

fex_eq:
	bsr	fex_cmp
	beq	fex_true
fex_false:
	moveq.l	#0,d0			;d0:d1:d2 = 0.0
	moveq.l	#0,d1
	moveq.l	#0,d2
	rts

fex_true:
	move.w	#$BFFF,d0		;d0:d1:d2 = -1.0
	move.l	#$80000000,d1
	moveq.l	#0,d2
	rts

fex_ne:
	bsr	fex_cmp
	bne	fex_true
	bra	fex_false

fex_lt:
	bsr	fex_cmp
	blo	fex_true
	bra	fex_false

fex_le:
	bsr	fex_cmp
	bls	fex_true
	bra	fex_false

fex_gt:
	bsr	fex_cmp
	bhi	fex_true
	bra	fex_false

fex_ge:
	bsr	fex_cmp
	bhs	fex_true
	bra	fex_false

fex_cmp:
	ext.l	d0			;ʃ[h
	ext.l	d3
	move.w	#$7FFF,d6
	and.w	d6,d0
	beq	fex_cmp_za		;(0܂͔񐳋K)-?
fex_cmp1:
	cmp.w	d6,d0
	beq	fex_cmp_nia		;(INF܂NAN)-?
fex_cmp2:
	and.w	d6,d3
	beq	fex_cmp_zb		;?-(0܂͔񐳋K)
fex_cmp3:
	cmp.w	d6,d3
	beq	fex_cmp_nib		;?-(INF܂NAN)
fex_cmp4:
;w̕
;񐳋K͈ꎞIɐKĂ̂+$3FFFł͑Ȃ
;INF$7FFFɂȂĂ̂+$8000傫ȐĂ͂ȂȂ
	add.w	#$8000,d0
	add.w	#$8000,d3
	tst.l	d0
	bmi	fex_cmp6		;-?
;-?
	tst.l	d3
	bmi	fex_cmp7		;-
;-
	cmp.w	d3,d0
	bne	fex_cmp59
	cmp.l	d4,d1
	bne	fex_cmp59
	cmp.l	d5,d2
fex_cmp59:
	rts

;-?
fex_cmp6:
	tst.l	d3
	bpl	fex_cmp8		;-
;-
	cmp.w	d0,d3
	bne	fex_cmp69
	cmp.l	d1,d4
	bne	fex_cmp69
	cmp.l	d2,d5
fex_cmp69:
	rts

;-
fex_cmp7:
	moveq.l	#1,d0
	rts

;-
fex_cmp8:
	moveq.l	#-1,d0
	rts

fex_cmp_za:				;(0܂͔񐳋K)-?
	move.l	d1,d6
	or.l	d2,d6
	beq	fex_cmp1		;0-?
fex_cmp_za1:				;񐳋KꎞIɐK
	tst.l	d1
	bmi	fex_cmp1
	subq.w	#1,d0
	add.l	d2,d2
	addx.l	d1,d1
	bra	fex_cmp_za1

fex_cmp_nia:				;(INF܂NAN)-?
	add.l	d1,d1
	or.l	d2,d1
	bne	fex_cmp_nan		;NAN-?
	cmp.l	d3,d0			;Ŕr
	bne	fex_cmp2		;INF-?
	bra	fex_cmp_nan		;INF-INF=NAN܂(-INF)-(-INF)=NAN

fex_cmp_zb:				;?-(0܂͔񐳋K)
	move.l	d4,d6
	or.l	d5,d6
	beq	fex_cmp3		;?-0
fex_cmp_zb1:				;񐳋KꎞIɐK
	tst.l	d4
	bmi	fex_cmp3
	subq.w	#1,d0
	add.l	d5,d5
	addx.l	d4,d4
	bra	fex_cmp_zb1

fex_cmp_nib:				;?-(INF܂NAN)
	add.l	d4,d4
	or.l	d5,d4
	beq	fex_cmp4		;?-INF
;	bra	fex_cmp_nan		;?-NAN
fex_cmp_nan:
	move.w	#$7FFF,d0		;rs\Ȃ̂NANԂ
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	addq.l	#4,sp			;true/falsej
	rts

fex_and:
	and.l	d1,d0
	rts

fex_xor:
	eor.l	d1,d0
	rts

fex_or:
	or.l	d1,d0
	rts

;----------------------------------------------------------------
;	gxZ[`
;
;	d0: b31`b16	(gp)
;	    b15		= 
;	    b14`b0	= w
;	d1,d2		= 
;----------------------------------------------------------------

;----------------------------------------------------------------
;	gxɕϊ
;	in :a0 = ϊւ̃|C^
;	out:d0:d1:d2 = (d0.l=-1ȂG[)
strtox::
	move.l	a0,-(sp)
	movem.l	d3-d7/a1-a2,-(sp)
	bsr	getsign			;𓾂
	move.w	d7,-(sp)
	moveq.l	#0,d6
	cmpi.b	#'.',(a0)
	bne	strtox1
	addq.l	#1,a0
	moveq.l	#-1,d6
	moveq.l	#$20,d7
	or.b	(a0),d7
	cmp.b	#'e',d7
	bne	strtox1
	moveq.l	#0,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	bra	strtox8

strtox1:
	bsr	getdigit		;ŏ1𓾂
	bmi	strtox99		;lłȂ΃G[
	move.l	d7,d0
	bsr	ltox
	bra	strtox3

strtox2:
	move.w	#$4002,d3
	move.l	#$A0000000,d4
	moveq.l	#0,d5			;d3:d4:d5 = +10.0
	bsr	xmul
	move.w	d0,d3
	move.l	d1,d4
	move.l	d2,d5
	move.l	d7,d0
	bsr	ltox
	bsr	xadd
	tst.l	d6
	bpl	strtox3
	subq.w	#1,d6
strtox3:
	bsr	getdigit
	bpl	strtox2
	move.b	(a0),d7
	cmp.b	#'.',d7
	bne	strtox4
	tst.l	d6
	bmi	strtox9			;2ڂ̏_Ȃ炻ŏI
	addq.l	#1,a0
	move.w	#-1,d6
	swap.w	d6
	bra	strtox3

strtox4:
	or.b	#$20,d7
	cmp.b	#'e',d7
	bne	strtox9			;w͂Ȃ
strtox8:
	addq.l	#1,a0
	bsr	getsign			;w𓾂
	move.w	d7,d3
	bsr	getdigit		;ŏ1𓾂
	bmi	strtox99		;lłȂ΃G[
	move.w	d7,d4
	bra	strtox6

strtox5:
	add.w	d4,d4
	move.w	d4,d5
	add.w	d4,d4
	add.w	d4,d4
	add.w	d5,d4			;d4.l *= 10
	add.w	d7,d4
strtox6:
	bsr	getdigit
	bpl	strtox5
	tst.w	d3
	bmi	strtox7
	add.w	d4,d6			;w͐
	bra	strtox9

strtox7:
	sub.w	d4,d6			;w͕

strtox9:
	movem.l	d0-d2,-(sp)
	move.w	#$3FFF,d0
	move.l	#$80000000,d1
	moveq.l	#0,d2			;d0:d1:d2 = 1.0
	moveq.l	#13-1,d7
	tst.w	d6
	bmi	strtox_m
					;10iw10^n𓾂
strtox_p:				;̎w(1.0ȏ)̏ꍇ
	lea.l	(decexptblp,pc),a1
	lea.l	(decmantblp,pc),a2
	rol.w	#3-1,d6
strtox_p1:
	move.w	(a1)+,d3
	movem.l	(a2)+,d4-d5
	add.w	d6,d6
	bpl	strtox_p2
	bsr	xmul			;10̗ݏ|
strtox_p2:
	dbra	d7,strtox_p1
	bra	strtox10

strtox_m:				;̎w(1.0)̏ꍇ
	lea.l	(decexptblm,pc),a1
	lea.l	(decmantblm,pc),a2
	neg.w	d6
	rol.w	#3-1,d6
strtox_m1:
	move.w	(a1)+,d3
	movem.l	(a2)+,d4-d5
	add.w	d6,d6
	bpl	strtox_m2
	bsr	xmul			;10̗ݏ|
strtox_m2:
	dbra	d7,strtox_m1

strtox10:
	movem.l	(sp)+,d3-d5		;
	bsr	xmul			;~(10^w)

	tst.w	(sp)+
	bpl	strtox11
	or.w	#$8000,d0		;͕
strtox11:
	swap.w	d0
	clr.w	d0
	swap.w	d0
	movem.l	(sp)+,d3-d7/a1-a2
	addq.l	#4,sp			;X^bN␳
	rts

strtox99:				;G[̏ꍇ
	moveq.l	#-1,d0
	addq.l	#2,sp			;X^bN␳
	movem.l	(sp)+,d3-d7/a1-a2
	movea.l	(sp)+,a0		;|C^ɖ߂
	rts

;----------------------------------------------------------------
;	𓾂
getsign:
	move.b	(a0),d7
	cmp.b	#'-',d7
	beq	getsignn
	cmp.b	#'+',d7
	bne	getsignp
	addq.l	#1,a0
getsignp:
	moveq.l	#0,d7
	rts

getsignn:
	addq.l	#1,a0
	moveq.l	#-1,d7
	rts

;----------------------------------------------------------------
;	1
getdigit:
	moveq.l	#0,d7
	move.b	(a0)+,d7
	cmp.b	#'_',d7
	beq	getdigit
	sub.b	#'0',d7
	bcs	getdigit9
	cmp.b	#9,d7
	bhi	getdigit9
	tst.w	d7
	rts

getdigit9:
	subq.l	#1,a0
	moveq.l	#-1,d7
	rts

;----------------------------------------------------------------
;	𔽓]
;	in :d0:d1:d2 = gxl
;	out:d0:d1:d2 = 
xneg::
	bchg.l	#15,d0			;𔽓]
	rts

;----------------------------------------------------------------
;	2r(A-B)
;	in :d0:d1:d2 = gxlA
;	    d3:d4:d5 = gxlB
;	out:ccr = 
xcmp::
	move.l	d6,-(sp)
	tst.w	d0
	bmi	xcmp_m			;A<0̂Ƃ
	tst.w	d3
	bmi	xcmp_hiz
	cmp.w	d3,d0
	bcs	xcmp_lo
	bhi	xcmp_hi
	cmp.l	d4,d1
	bcs	xcmp_lo
	bhi	xcmp_hi
	cmp.l	d5,d2
	bcs	xcmp_lo
	bhi	xcmp_hi
	move.w	#$0004,ccr		;A=B
	move.l	(sp)+,d6
	rts

xcmp_m:					;A>0̂Ƃ
	tst.w	d3
	bpl	xcmp_loz
	cmp.w	d3,d0
	bcs	xcmp_hi
	bhi	xcmp_lo
	cmp.l	d4,d1
	bcs	xcmp_hi
	bhi	xcmp_lo
	cmp.l	d5,d2
	bcs	xcmp_hi
	bhi	xcmp_lo
xcmp_eq:
	move.w	#$0004,ccr		;A=B
	move.l	(sp)+,d6
	rts

xcmp_hiz:
	move.w	d0,d6
	or.w	d3,d6
	and.w	#$7FFF,d6
	bne	xcmp_hi
	move.l	d1,d6
	or.l	d2,d6
	or.l	d4,d6
	or.l	d5,d6
	beq	xcmp_eq			;-0.0 == +0.0
xcmp_hi:
	move.w	#$0000,ccr		;A>B
	move.l	(sp)+,d6
	rts

xcmp_loz:
	move.w	d0,d6
	or.w	d3,d6
	and.w	#$7FFF,d6
	bne	xcmp_lo
	move.l	d1,d6
	or.l	d2,d6
	or.l	d4,d6
	or.l	d5,d6
	beq	xcmp_eq			;-0.0 == +0.0
xcmp_lo:
	move.w	#$0009,ccr		;A<B
	move.l	(sp)+,d6
	rts

;----------------------------------------------------------------
;	2Z(A=A-B)
;	in :d0:d1:d2 = gxlA
;	    d3:d4:d5 = gxlB
;	out:d0:d1:d2 = 
xsub::
	movem.l	d3-d7,-(sp)
	bchg.l	#15,d3			;𔽓]
	bra	xadd0			;A-B = A+(-B)

;----------------------------------------------------------------
;	2Z(A=A+B)
;	in :d0:d1:d2 = gxlA
;	    d3:d4:d5 = gxlB
;	out:d0:d1:d2 = 
xadd::
	movem.l	d3-d7,-(sp)
xadd0:
	move.w	d0,d6
	eor.w	d3,d6
	swap.w	d6
	move.w	d0,d6
	move.w	#$7FFF,d7
	and.w	d7,d0
	beq	xadd_za			;A=0 or 񐳋K
	cmp.w	d7,d0
	beq	xadd_nia		;A=NAN or }INF
xadd1:
	and.w	d7,d3
	beq	xadd_zb			;B=0 or 񐳋K
	cmp.w	d7,d3
	beq	xadd_nib		;B=NAN or }INF
xadd2:
	tst.l	d6
	bmi	xadd_s			;AB̕قȂ(Z)

;----------------------------------------------------------------
;	̓̉Z
xadd_a:
	cmp.w	d3,d0
	beq	xadd_ae			;AB̎w
	bgt	xadd_a1			;A>B̂Ƃ(ꎞK̂ߕtr)
	exg.l	d0,d3			;A<BȂ2
	exg.l	d1,d4
	exg.l	d2,d5
xadd_a1:
	add.l	d2,d2			;A <<= 1 (rbg폜)
	addx.l	d1,d1
	move.w	d0,d7
	sub.w	d3,d7
	subq.w	#2,d7
	bcs	xadd_a5			;A1傫
	cmp.w	#64-1,d7
	bcc	xadd_a6			;64ȏ傫Â܂ܕԂ
xadd_a2:				;AƏ_ʒu킹
	lsr.l	#1,d4
	roxr.l	#1,d5
	dbra	d7,xadd_a2
xadd_a5:
	move.w	d5,d3
	lsr.w	#1,d3			;ŉʃrbgo(X)
	addx.l	d5,d2			;A += B(B̍ŉʃrbgۂ߂)
	addx.l	d4,d1
	bcc	xadd_a6			;オ肵ĂȂ
	addq.w	#1,d0			;w1
	cmp.w	#$7FFF,d0
	beq	xadd_infa		;I[o[t[
	moveq.l	#0,d3
	lsr.l	#1,d1			;A /= 2
	roxr.l	#1,d2
	move.w	d2,d3			;ŉʃrbgۂ߂
	and.w	#$0001,d3
	addx.l	d3,d2
	moveq.l	#0,d3
	addx.l	d3,d1
xadd_a6:
	move.w	#$0010,ccr		;X=1
	roxr.l	#1,d1			;ʂ̐rbgt
	roxr.l	#1,d2			;(VtgO̍ŉʃrbg͕K0)
	bra	xadd_ae0		;ꎞKȂ琳Kɖ߂AԂ

xadd_ae:				;AB̎wƂ
	addq.w	#1,d0			;w1
	cmp.w	#$7FFF,d0
	beq	xadd_infa		;I[o[t[
	add.l	d5,d2			;A += B
	addx.l	d4,d1			;(rbgĂ̂ŕKL[)
	roxr.l	#1,d1			;A /= 2
	roxr.l	#1,d2
	moveq.l	#0,d3			;ۂ߂s
	roxl.w	#1,d3			;Vtgł݂͂ŉʃrbg
	add.l	d3,d2			;ŉʃrbg؂グ(01)
	moveq.l	#0,d3
	addx.l	d3,d1
xadd_ae0:
	tst.w	d0
	bpl	xadd_ae5		;ʂK̏ꍇ
xadd_ae1:				;ꎞK񐳋Kɖ߂
	addq.w	#1,d0
	lsr.l	#1,d1
	roxr.l	#1,d2
	tst.w	d0
	bne	xadd_ae1
	moveq.l	#0,d3			;ۂ߂s
	roxl.w	#1,d3			;Vtgł݂͂ŉʃrbg
	add.l	d3,d2			;ŉʃrbg؂グ(01)
	moveq.l	#0,d3
	addx.l	d3,d1
xadd_ae5:
	tst.w	d6			;AƓ
	bpl	xadd_ae9
	or.w	#$8000,d0
xadd_ae9:
	movem.l	(sp)+,d3-d7
	rts

xadd_infa:				;INFɂȂ(AƓ)
	tst.w	d6
	bpl	xadd_infa1
	or.w	#$8000,d0
xadd_infa1:
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7
	rts

;----------------------------------------------------------------
;	̈قȂ鐔̉Z
xadd_s:
	cmp.w	d3,d0
	beq	xadd_se			;AB̎w
	bgt	xadd_s1			;A>B̂Ƃ(ꎞK̂ߕtr)
	exg.l	d0,d3			;A<BȂ2ĕ𔽓]
	exg.l	d1,d4
	exg.l	d2,d5
	not.w	d6
xadd_s1:
	add.l	d2,d2			;A <<= 1	(rbg폜)
	addx.l	d1,d1
	move.w	d0,d7
	sub.w	d3,d7
	subq.w	#2,d7
	bcs	xadd_s5			;A1傫
	cmp.w	#64-1,d7
	bcc	xadd_s6			;64ȏ傫Â܂ܕԂ
xadd_s2:				;AƏ_ʒu킹
	lsr.l	#1,d4
	roxr.l	#1,d5
	dbra	d7,xadd_s2
xadd_s5:
	move.w	d5,d3
	lsr.w	#1,d3			;ŉʃrbgo(X)
	subx.l	d5,d2			;A -= B(B̍ŉʃrbgۂ߂)
	subx.l	d4,d1
	bcc	xadd_s6			;肵ĂȂ
	subq.w	#1,d0			;w1
	bra	xadd_se1		;ꎞKȂ琳Kɖ߂AԂ

xadd_s6:
	move.w	#$0010,ccr		;X=1
	roxr.l	#1,d1			;ʂ̐rbgt
	roxr.l	#1,d2			;(VtgO̍ŉʃrbg͕K0)
	bra	xadd_se1		;ꎞKȂ琳Kɖ߂AԂ

xadd_se:				;AB̎wƂ
	sub.l	d5,d2			;A -= B
	subx.l	d4,d1
	bhi	xadd_se1
	neg.l	d2			;A<B̂ŕ𔽓]
	negx.l	d1
	beq	xadd_sez		;ʂ0ɂȂ
	not.w	d6
xadd_se1:
	tst.w	d0
	bmi	xadd_ae1		;ꎞK񐳋Kɖ߂
	beq	xadd_se5		;łɐK/񐳋KĂ
	tst.l	d1
	bmi	xadd_se5		;KĂ
xadd_se2:
	subq.w	#1,d0
	add.l	d2,d2
	addx.l	d1,d1
	bmi	xadd_se5		;KI
	subq.w	#1,d3
	bne	xadd_se2		;w0ɂȂ琳K𒆒f
xadd_se5:
	tst.w	d6			;AƓ
	bpl	xadd_se9
	or.w	#$8000,d0
xadd_se9:
	movem.l	(sp)+,d3-d7
	rts

xadd_sez:				;ʂ0ɂȂ
	moveq.l	#0,d0			;+0.0
	movem.l	(sp)+,d3-d7
	rts

xadd_za:				;A=0 or 񐳋K
	move.l	d1,d7
	or.l	d2,d7
	bne	xadd_za1
	move.l	d3,d0			;0+B = B
	move.l	d4,d1
	move.l	d5,d2
	move.w	#$7FFF,d7
	and.w	d7,d3
	beq	xadd_z			;0+0 or 񐳋K
	cmp.w	d7,d3
	beq	xadd_nib		;0+NAN or 0+INF
	movem.l	(sp)+,d3-d7
	rts

xadd_z:
	or.l	d4,d3
	beq	xadd_z9			;0+0
	move.w	d6,d0			;0+񐳋K
	swap.w	d6
	eor.w	d6,d0
	and.w	#$8000,d0		;B̕
	movem.l	(sp)+,d3-d7
	rts

xadd_z9:				;0+0
	move.w	d6,d0			;(-0.0)+(-0.0)=-0.0
	swap.w	d6			;ȊO +0.0
	not.w	d6
	and.w	d6,d0
	and.w	#$8000,d0
	movem.l	(sp)+,d3-d7
	rts

xadd_za1:				;񐳋KꎞIɐK
	move.w	#$7FFF,d7
xadd_za2:
	tst.l	d1
	bmi	xadd1
	subq.w	#1,d0
	add.l	d2,d2
	addx.l	d1,d1
	bra	xadd_za2

xadd_nia:				;A=NAN or }INF
	add.l	d1,d1
	or.l	d2,d1
	bne	xadd_n			;0łȂȂNAN
	and.w	d7,d3			;B̎w
	cmp.w	d7,d3
	bne	xadd_ni9		;INF+B = INF
	add.l	d4,d4
	or.l	d5,d4
	bne	xadd_n			;0łȂȂNAN
	tst.l	d6
	bmi	xadd_n			;INF-INF = NAN	(AB̕قȂ)
xadd_ni9:				;Â܂ܕԂ
	move.w	d6,d0
	movem.l	(sp)+,d3-d7
	rts

xadd_zb:				;B=0 or 񐳋K
	move.l	d4,d7
	or.l	d5,d7
	beq	xadd_ae0		;A+0 = AԂ(ꎞKȂ񐳋Kɖ߂)
xadd_zb1:				;񐳋KꎞIɐK
	tst.l	d4
	bmi	xadd2
	subq.w	#1,d3
	add.l	d5,d5
	addx.l	d4,d4
	bra	xadd_zb1

xadd_nib:				;B=NAN or }INF
	add.l	d4,d4
	or.l	d5,d4
	bne	xadd_n			;0łȂȂNAN
	move.l	(sp),d0			;A+INF = INF (B̕)
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7
	rts

xadd_n:					;NANԂ
	move.w	#$7FFF,d0
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	movem.l	(sp)+,d3-d7
	rts

;----------------------------------------------------------------
;	2Z(A=A*B)
;	in :d0:d1:d2 = gxlA
;	    d3:d4:d5 = gxlB
;	out:d0:d1:d2 = 
xmul::
	movem.l	d3-d7,-(sp)
	move.w	d0,d6
	eor.w	d3,d6			;ʂ̕
	move.w	#$7FFF,d7
	and.w	d7,d0
	beq	xmul_za			;A=0 or 񐳋K
	cmp.w	d7,d0
	beq	xmul_nia		;A=NAN or }INF
xmul1:
	and.w	d7,d3
	beq	xmul_zb			;B=0 or 񐳋K
	cmp.w	d7,d3
	beq	xmul_nib		;B=NAN or }INF
xmul2:
	movem.w	d0/d3/d6,-(sp)		;A1234 * B1234

;			A1  A2  A3  A4
;		     ~ B1  B2  B3  B4
;		    -------------------
;			        44H 44L
;			    34H 34L
;			24H 24L
;		    14H 14L 43H 43L
;			33H 33L
;		    23H 23L
;		13H 13L 42H 42L
;		    32H 32L
;		22H 22L
;	    12H 12L 41H 41L
;		31H 31L
;	    21H 21L
;	11H 11L
;	===d5== ===d6== =d7=

	move.w	d1,d7
	mulu.w	d5,d7			;A2*B4
	clr.w	d7
	swap.w	d7
	move.w	d2,d6			;24H
	mulu.w	d4,d6			;A4*B2
	clr.w	d6
	swap.w	d6
	add.l	d6,d7			;42H
	swap.w	d2			;A43
	move.l	d5,d6
	swap.w	d6
	mulu.w	d2,d6			;A3*B3
	clr.w	d6
	swap.w	d6
	add.l	d6,d7			;33H

	move.l	d1,d6
	swap.w	d6
	mulu.w	d5,d6			;A1*A4
	add.l	d6,d7			;14L
	move.l	d7,d6
	clr.w	d6
	addx.w	d6,d6			;14H(+グ)
	swap.w	d6

	swap.w	d5
	move.w	d1,d3
	mulu.w	d5,d3			;A2*B3
	add.w	d3,d7			;23L
	clr.w	d3
	swap.w	d3
	addx.l	d3,d6			;23H(+グ)

	move.w	d4,d3
	mulu.w	d2,d3			;A3*B2
	add.w	d3,d7			;32L
	clr.w	d3
	swap.w	d3
	addx.l	d3,d6			;32H(+グ)

	move.l	d1,d3
	swap.w	d3
	mulu.w	d3,d5			;A1*B3
	mulu.w	d4,d3			;A1*B2
	move.w	d1,d0
	mulu.w	d4,d0			;A2*B2
	add.l	d5,d0			;13HL+22HL
	moveq.l	#0,d5
	addx.w	d5,d5			;(グ)
	add.l	d0,d6
	move.l	d3,d0
	swap.w	d3
	clr.w	d0
	swap.w	d0
	addx.l	d0,d5			;12H(+グ)

	swap.w	d4
	move.w	d2,d0
	swap.w	d2
	mulu.w	d4,d2			;A4*B1
	add.w	d2,d7			;41L
	swap.w	d2
	move.w	d2,d3
	addx.l	d3,d6			;12L:41H(+グ)
	move.l	d1,d3
	swap.w	d3
	mulu.w	d4,d3			;A1*B1
	addx.l	d3,d5			;11HL(+グ)

	mulu.w	d4,d0			;A3*B1
	add.l	d0,d6			;31HL
	moveq.l	#0,d3
	addx.l	d3,d5			;(グ)

	mulu.w	d4,d1			;A2*B1
	swap.w	d1
	move.w	d1,d3
	clr.w	d1
	add.l	d1,d6			;21L
	addx.l	d3,d5			;21H(+グ)

	move.l	d5,d1
	move.l	d6,d2
	movem.w	(sp)+,d0/d3/d6
	ext.l	d0			;(ꎞKȂwȂ̂)
	ext.l	d3
	add.l	d3,d0			;w
	sub.l	#$3FFF-1,d0		;oCAX
	tst.l	d1
	bmi	xmul5
	subq.l	#1,d0			;K
	add.w	d7,d7
	roxl.l	#1,d2
	roxl.l	#1,d1
xmul5:
	tst.w	d7			;ŉʃrbgŊۂ߂s
	bpl	xmul6
	moveq.l	#0,d3
	addq.l	#1,d2
	addx.l	d3,d1
	bcc	xmul6
	addq.l	#1,d0			;ۂ߂Ōオ肵
	move.l	#$80000000,d1		;(ʂ$80000000_00000000)
xmul6:
	cmp.w	#$7FFF,d0		;([h͈͂Ɏ܂)
	bcs	xmul8			;ʂ̎w͈͓
	beq	xmul_i
	cmp.w	#-64,d0
	bgt	xmul7			;ꎞK͈͓̔
	tst.l	d0
	bmi	xmul_z			;lA_[t[	0
	bra	xmul_i			;  I[o[t[	INF

xmul7:					;ꎞK񐳋Kɖ߂
	addq.w	#1,d0
	lsr.l	#1,d1
	roxr.l	#1,d2
	tst.w	d0
	bne	xmul7
	moveq.l	#0,d3			;ۂ߂s
	roxl.w	#1,d3			;Vtgł݂͂ŉʃrbg
	add.l	d3,d2			;ŉʃrbg؂グ(01)
	moveq.l	#0,d3
	addx.l	d3,d1
xmul8:
	tst.w	d6			;ʂ̕
	bpl	xmul9
	or.w	#$8000,d0
xmul9:
	movem.l	(sp)+,d3-d7
	rts

xmul_za:				;A=0 or 񐳋K
	move.l	d1,d7
	or.l	d2,d7
	bne	xmul_za1		;񐳋K̏ꍇ
	move.w	#$7FFF,d7
	and.w	d7,d3
	cmp.w	d7,d3
	beq	xmul_n			;0*NAN or 0*INF = NAN
xmul_z:
	move.w	d6,d0			;0*B = 0
	and.w	#$8000,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7
	rts

xmul_za1:				;񐳋KꎞIɐK
	move.w	#$7FFF,d7
xmul_za2:
	tst.l	d1
	bmi	xmul1
	subq.w	#1,d0
	add.l	d2,d2
	addx.l	d1,d1
	bra	xmul_za2

xmul_nia:				;A=NAN or }INF
	add.l	d1,d1
	or.l	d2,d1
	bne	xmul_n			;0łȂȂNAN
	and.w	d7,d3			;B̎w
	beq	xmul_nia1		;B=0 or 񐳋K
	cmp.w	d7,d3
	bne	xmul_i			;INF*B = INF
	add.l	d4,d4
	or.l	d5,d4
	bne	xmul_n			;0łȂȂNAN
xmul_i:					;INFԂ
	move.w	d6,d0
	or.w	#$7FFF,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7
	rts

xmul_nia1:				;B=0 or 񐳋K
	move.l	d4,d7
	or.l	d5,d7
	beq	xmul_n			;INF*0 = NAN
	bra	xmul_i			;INF*񐳋K = INF

xmul_zb:				;B=0 or 񐳋K
	move.l	d4,d7
	or.l	d5,d7
	beq	xmul_z			;A*0 = 0
xmul_zb1:				;񐳋KꎞIɐK
	tst.l	d4
	bmi	xmul2
	subq.w	#1,d3
	add.l	d5,d5
	addx.l	d4,d4
	bra	xmul_zb1

xmul_nib:				;B=NAN or }INF
	add.l	d4,d4
	or.l	d5,d4
	beq	xmul_i			;A*INF = INF
xmul_n:					;NANԂ
	move.w	#$7FFF,d0
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	movem.l	(sp)+,d3-d7
	rts

;----------------------------------------------------------------
;	2Z(A=A/B)
;	in :d0:d1:d2 = gxlA
;	    d3:d4:d5 = gxlB
;	out:d0:d1:d2 = 
xdiv::
	movem.l	d3-d7,-(sp)
	move.w	d0,d6
	eor.w	d3,d6			;ʂ̕
	move.w	#$7FFF,d7
	and.w	d7,d0
	beq	xdiv_za			;A=0 or 񐳋K
	cmp.w	d7,d0
	beq	xdiv_nia		;A=NAN or }INF
xdiv1:
	and.w	d7,d3
	beq	xdiv_zb			;B=0 or 񐳋K
	cmp.w	d7,d3
	beq	xdiv_nib		;B=NAN or }INF
xdiv2:
	ext.l	d0			;(ꎞKȂwȂ̂)
	ext.l	d3
	sub.l	d3,d0			;w
	add.l	#$3FFF,d0		;oCAX

	moveq.l	#0,d3
	cmp.l	d4,d1
	bne	xdiv3
	cmp.l	d5,d2
xdiv3:
	bcc	xdiv4
	moveq.l	#0,d7			;A<B
	subq.l	#1,d0
	bra	xdiv5

xdiv4:					;A>B
	moveq.l	#1,d7
	sub.l	d5,d2
	subx.l	d4,d1
xdiv5:					;Z[v
	add.l	d7,d7
	addx.l	d3,d3
	bcs	xdiv8			;ZI
	add.l	d2,d2			;]<<1
	addx.l	d1,d1
	bcs	xdiv7
	cmp.l	d4,d1
	bcs	xdiv5
	bne	xdiv7
	cmp.l	d5,d2
	bcs	xdiv5
xdiv7:
	sub.l	d5,d2
	subx.l	d4,d1
	addq.w	#1,d7
	bra	xdiv5

xdiv8:
	roxr.l	#1,d3
	roxr.l	#1,d7
	add.l	d2,d2
	addx.l	d1,d1
	bcs	xdiv9
	cmp.l	d4,d1
	bcs	xdiv10
	bne	xdiv9
	cmp.l	d5,d2
	bcs	xdiv10
xdiv9:
	moveq.l	#0,d1
	addq.l	#1,d7
	addx.l	d1,d3
	bcc	xdiv10
	addq.l	#1,d0			;ۂ߂Ōオ肵
	move.l	#$80000000,d3		;(ʂ$80000000_00000000)

xdiv10:
	move.l	d3,d1
	move.l	d7,d2
	cmp.w	#$7FFF,d0		;([h͈͂Ɏ܂)
	bcs	xdiv24			;ʂ̎w͈͓
	cmp.w	#-64,d0
	bgt	xdiv23			;ꎞK͈͓̔
	tst.l	d0
	bmi	xdiv_z			;lA_[t[	0
	bra	xdiv_i			;  I[o[t[	INF

xdiv23:					;ꎞK񐳋Kɖ߂
	addq.w	#1,d0
	lsr.l	#1,d1
	roxr.l	#1,d2
	tst.w	d0
	bne	xdiv23
	moveq.l	#0,d3			;ۂ߂s
	roxl.w	#1,d3			;Vtgł݂͂ŉʃrbg
	add.l	d3,d2			;ŉʃrbg؂グ(01)
	moveq.l	#0,d3
	addx.l	d3,d1
xdiv24:
	tst.w	d6			;ʂ̕
	bpl	xdiv25
	or.w	#$8000,d0
xdiv25:
	movem.l	(sp)+,d3-d7
	rts

xdiv_za:				;A=0 or 񐳋K
	move.l	d1,d7
	or.l	d2,d7
	bne	xdiv_za5		;񐳋K̏ꍇ
	move.w	#$7FFF,d7
	and.w	d7,d3			;B̎w
	beq	xdiv_za1		;B=0 or 񐳋K
	cmp.w	d7,d3
	bne	xdiv_z			;0/B = 0
	add.l	d4,d4
	or.l	d5,d4
	bne	xdiv_n			;0łȂȂNAN
xdiv_z:
	move.w	d6,d0			;0/B = 0
	and.w	#$8000,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7
	rts

xdiv_za1:				;B=0 or 񐳋K
	move.l	d4,d7
	or.l	d5,d7
	bne	xdiv_z			;0/񐳋K = 0
	bra	xdiv_n			;0/0 = NAN

xdiv_za5:				;񐳋KꎞIɐK
	move.w	#$7FFF,d7
xdiv_za6:
	tst.l	d1
	bmi	xdiv1
	subq.w	#1,d0
	add.l	d2,d2
	addx.l	d1,d1
	bra	xdiv_za6

xdiv_nia:				;A=NAN or }INF
	add.l	d1,d1
	or.l	d2,d1
	bne	xdiv_n			;0łȂȂNAN
	and.w	d7,d3			;B̎w
	cmp.w	d7,d3
	beq	xdiv_n			;INF/NAN, INF/INF = NAN
xdiv_i:					;INFԂ
	move.w	d6,d0
	or.w	#$7FFF,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7
	rts

xdiv_zb:				;B=0 or 񐳋K
	move.l	d4,d7
	or.l	d5,d7
	beq	xdiv_i			;A/0 = INF
xdiv_zb1:				;񐳋KꎞIɐK
	tst.l	d4
	bmi	xdiv2
	subq.w	#1,d3
	add.l	d5,d5
	addx.l	d4,d4
	bra	xdiv_zb1

xdiv_nib:				;B=NAN or }INF
	add.l	d4,d4
	or.l	d5,d4
	beq	xdiv_z			;A/INF = 0
xdiv_n:					;NANԂ
	move.w	#$7FFF,d0
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	movem.l	(sp)+,d3-d7
	rts

;----------------------------------------------------------------
;	K
;	in :d0:d1:d2 = gxl
;	out:d0:d1:d2 = 
normalize:
	move.l	d3,-(sp)
	move.w	d0,d3
	and.w	#$7FFF,d3
	beq	normalize9		;w0ȂȂɂȂ
	cmp.w	#$7FFF,d3
	beq	normalize_ni		;NAN or }INF
	tst.l	d1
	bmi	normalize9		;łɐKĂ
	bne	normalize1
	tst.l	d2
	beq	normalize_z		;0Ȃ0
normalize1:
	subq.w	#1,d0
	add.l	d2,d2
	addx.l	d1,d1
	bmi	normalize9		;KI
	subq.w	#1,d3
	bne	normalize1		;w0ɂȂ琳K𒆒f
normalize9:
	move.l	(sp)+,d3
	rts

normalize_z:				;0
	and.w	#$8000,d0
	bra	normalize9

normalize_ni:				;NAN or }INF
	add.l	d1,d1
	or.l	d2,d1
	beq	normalize9		;INF
normalize_n:				;NAN
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	bra	normalize9

;----------------------------------------------------------------
;	64bitgxɕϊ
;	in :d1:d0 = 64bit
;	out:d0:d1:d2 = 
qtox:
	move.l	d0,d2
	or.l	d1,d2
	beq	qtox9			;0
	tst.l	d1
	beq	qtox3			;d1=0Ȃ̂ŉ32bitgxɂ
	bpl	qtox2
;
	neg.l	d0
	negx.l	d1
	bsr	qtox1
	bchg.l	#15,d0
qtox9:
	rts

;d1=0Ȃ̂ŉ32bitgxɂ
qtox3:
	moveq.l	#0,d2
	move.l	d0,d1
	bra	ltox1

qtox1:
	tst.l	d1
	beq	qtox3			;d1=0Ȃ̂ŉ32bitgxɂ
;d1=0ł͂Ȃ
qtox2:
	move.l	d0,d2
	beq	qtox4			;d0=0Ȃ̂ŏ32bitVtg
;d1,d00łȂ̂őŜVtg
	move.l	#$3FFF+63,d0		;w2^63
	tst.l	d1
	bra	qtox7

qtox6:
	add.l	d2,d2
	addx.l	d1,d1
qtox7:
	dbmi	d0,qtox6
	rts

;d0=0Ȃ̂ŏ32bitVtg
qtox4:
;d2=0
	move.l	d1,d0
	swap.w	d0
	tst.w	d0
	beq	qtox5
	move.l	#$3FFF+63,d0		;w2^63
	tst.l	d1
	bra	ltox3

qtox5:
	move.l	#$3FFF+47,d0		;w2^47
	tst.w	d1
	bra	ltox7

;----------------------------------------------------------------
;	O[hgxɕϊ
;	in :d0 = O[hl
;	out:d0:d1:d2 = 
ltox::
	moveq.l	#0,d2
	move.l	d0,d1
	beq	ltox9			;0̏ꍇ
	bpl	ltox1
	neg.l	d0			;ȂϊɕrbgZbg
	move.l	d0,d1
	bsr	ltox1
	bchg.l	#15,d0
ltox9:
	rts

ltox1:
	swap.w	d0
	tst.w	d0
	beq	ltox5
	move.l	#$3FFF+31,d0		;w2^31
	tst.l	d1
	bra	ltox3

ltox2:
	add.l	d1,d1			;VtgĐK
ltox3:
	dbmi	d0,ltox2
	rts

ltox5:					;$00000001`$0000FFFF̏ꍇ
	move.l	#$3FFF+15,d0		;w2^15
	tst.w	d1
	bra	ltox7

ltox6:
	add.w	d1,d1			;VtgĐK
ltox7:
	dbmi	d0,ltox6
	swap.w	d1
	rts

;----------------------------------------------------------------
;	Pxgxɕϊ
;	in :d0 = Pxl
;	out:d0:d1:d2 = 
stox::
	move.l	d0,d1
	move.l	d0,d2
	add.l	d2,d2			;rbg
	moveq.l	#0,d2
	roxr.w	#1,d2
	and.l	#$007FFFFF,d1		;
	swap.w	d0
	lsr.w	#7,d0			;d0.b=w
	tst.b	d0
	beq	stox_zn			;0 or 񐳋K
	cmp.b	#$FF,d0
	beq	stox_ni			;NAN or }INF
	lsl.l	#8,d1			;K
	bset.l	#31,d1			;rbg
	move.b	d0,d2
	add.w	#$3FFF-$7F,d2
	move.l	d2,d0			;w
	moveq.l	#0,d2
	rts

stox_zn:				;0 or 񐳋K
	move.l	d2,d0			;w
	tst.l	d1
	beq	stox_z			;0
	lsl.l	#8,d1			;񐳋K
	add.w	#$3FFF-$7F+1,d0
	moveq.l	#0,d2
	bra	normalize		;K

stox_z:
	rts

stox_ni:				;NAN or }INF
	or.w	#$7FFF,d2
	move.l	d2,d0			;w
	tst.l	d1
	beq	stox_i			;INF
	moveq.l	#-1,d1			;NANԂ
	moveq.l	#-1,d2
	rts

stox_i:
	moveq.l	#0,d1			;INFԂ
	moveq.l	#0,d2
	rts

;----------------------------------------------------------------
;	{xgxɕϊ
;	in :d0:d1 = {xl
;	out:d0:d1:d2 = 
dtox::
	move.l	d3,-(sp)
	move.l	d0,d2
	clr.w	d0
	swap.w	d0
	add.l	d0,d0
	lsr.w	#5,d0			;rbgƎw𕪗
	and.l	#$000FFFFF,d2
	tst.w	d0
	beq	dtox_zn			;0 or 񐳋K
	cmp.w	#$7FF,d0
	beq	dtox_ni			;NAN or }INF
	bset.l	#$14,d2			;rbg
	move.l	d1,d3
	move.w	d2,d3
	lsr.l	#5,d2
	ror.l	#5,d1
	ror.l	#5,d3
	swap.w	d1
	and.w	#$F800,d1
	swap.w	d2
	swap.w	d3
	move.w	d3,d2			;lsl #11,d2:d3 (rbgŏʂɏグ)
	exg.l	d1,d2
	add.w	#$3FFF-$3FF,d0
	add.w	d0,d0
	lsr.l	#1,d0			;rbgt
dtox_z:
	move.l	(sp)+,d3
	rts

dtox_zn:				;0 or 񐳋K
	lsr.l	#1,d0			;rbgt
	move.l	d2,d3
	or.l	d1,d3
	beq	dtox_z			;0
	add.w	#$3FFF-$3FF+12,d0	;񐳋K
	exg.l	d1,d2
	move.l	(sp)+,d3
	bra	normalize		;K

dtox_ni:				;NAN or }INF
	move.w	#$FFFF,d0
	lsr.l	#1,d0			;rbgt
	move.l	d2,d3
	or.l	d1,d3
	beq	dtox_i			;INF
	moveq.l	#-1,d1			;NANԂ
	moveq.l	#-1,d2
	move.l	(sp)+,d3
	rts

dtox_i:
	moveq.l	#0,d1			;INFԂ
	moveq.l	#0,d2
	move.l	(sp)+,d3
	rts

;----------------------------------------------------------------
;	pbNhfV}gxɕϊ
;	in :d0:d1:d2 = pbNhfV}
;	out:d0:d1:d2 = 
ptox::
	movem.l	d3-d7/a0-a1,-(sp)
	swap.w	d0
	move.w	d0,-(sp)
	and.w	#$7FFF,d0
	cmp.w	#$7FFF,d0
	beq	ptox_ni			;NAN or }INF
	clr.w	d0
	swap.w	d0
	moveq.l	#0,d3
	moveq.l	#0,d4
	moveq.l	#0,d5			;d3:d4:d5 = +0.0
	move.l	d2,-(sp)
	move.l	d1,d7
	moveq.l	#8+1-1,d6
	bra	ptox2

ptox1:					;BCD16`8ڂϊ
	move.w	#$4002,d3
	move.l	#$A0000000,d4
	moveq.l	#0,d5			;d3:d4:d5 = +10.0
	bsr	xmul
	move.w	d0,d3
	move.l	d1,d4
	move.l	d2,d5
	rol.l	#4,d7
	moveq.l	#0,d0
	move.w	d7,d0
ptox2:
	and.w	#$000F,d0
	cmp.w	#9,d0
	bls	ptox3
	moveq.l	#0,d0			;BCD͈̔͊OȂ0
ptox3:
	bsr	ltox
	bsr	xadd
	dbra	d6,ptox1

	move.l	(sp)+,d7
	moveq.l	#8-1,d6
ptox4:					;BCD7`0ڂϊ
	move.w	#$4002,d3
	move.l	#$A0000000,d4
	moveq.l	#0,d5			;d3:d4:d5 = +10.0
	bsr	xmul
	move.w	d0,d3
	move.l	d1,d4
	move.l	d2,d5
	rol.l	#4,d7
	moveq.l	#0,d0
	move.w	d7,d0
	and.w	#$000F,d0
	cmp.w	#9,d0
	bls	ptox5
	moveq.l	#0,d0			;BCD͈̔͊OȂ0
ptox5:
	bsr	ltox
	bsr	xadd
	dbra	d6,ptox4

	move.w	(sp),d3			;10iw2iϊ
	movem.l	d0-d2,-(sp)		;
	rol.w	#4,d3
	moveq.l	#3-1,d6
	moveq.l	#0,d7
ptox_e1:
	add.w	d7,d7
	move.w	d7,d5
	add.w	d7,d7
	add.w	d7,d7
	add.w	d5,d7			;d7.w *= 10
	rol.w	#4,d3
	move.w	d3,d5
	and.w	#$000F,d5
	cmp.w	#9,d5
	bls	ptox_e2
	moveq.l	#0,d5
ptox_e2:
	add.w	d5,d7
	dbra	d6,ptox_e1
	and.w	#$4000,d3
	beq	ptox_e3			;w͐
	neg.w	d7			;w𔽓]
ptox_e3:				;(d7.w = -999`999)
	move.w	#$3FFF,d0
	move.l	#$80000000,d1
	moveq.l	#0,d2			;d0:d1:d2 = 1.0
	sub.w	#16,d7			;ϊ̕␳(d7.w = -1015`983)
	moveq.l	#10-1,d6
	tst.w	d7
	bmi	ptox_m
					;10iw10^n𓾂
ptox_p:					;̎w(1.0ȏ)̏ꍇ
	lea.l	(decexptblp+3*2,pc),a0	;10^512Jn
	lea.l	(decmantblp+3*8,pc),a1
	rol.w	#6-1,d7			;(K1024ȉȂ̂Ŏw6bit͖)
ptox_p1:
	move.w	(a0)+,d3
	movem.l	(a1)+,d4-d5
	add.w	d7,d7
	bpl	ptox_p2
	bsr	xmul			;10̗ݏ|
ptox_p2:
	dbra	d6,ptox_p1
	bra	ptox_8

ptox_m:					;̎w(1.0)̏ꍇ
	lea.l	(decexptblm+3*2,pc),a0	;10^-512Jn
	lea.l	(decmantblm+3*8,pc),a1
	neg.w	d7
	rol.w	#6-1,d7			;(K1024ȉȂ̂Ŏw6bit͖)
ptox_m1:
	move.w	(a0)+,d3
	movem.l	(a1)+,d4-d5
	add.w	d7,d7
	bpl	ptox_m2
	bsr	xmul			;10̗ݏ|
ptox_m2:
	dbra	d6,ptox_m1

ptox_8:
	movem.l	(sp)+,d3-d5		;
	bsr	xmul			;~(10^w)
	tst.w	(sp)+
	bpl	ptox_9
	or.w	#$8000,d0		;͕
ptox_9:
	movem.l	(sp)+,d3-d7/a0-a1
	rts

ptox_ni:				;NAN or }INF
	move.w	(sp)+,d0
	add.l	d1,d1
	or.l	d2,d1
	bne	ptox_n			;0łȂȂNAN
ptox_i:					;INF
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7/a0-a1
	rts

ptox_n:					;NAN
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	movem.l	(sp)+,d3-d7/a0-a1
	rts

;----------------------------------------------------------------
;	gxO[hɕϊ
;	in :d0:d1:d2 = gxl
;	out:d0 = 
;	    d1 = I[o[t[ȂǂŕϊłȂ-1
xtol::
	move.w	d0,d2			;Z[u
	swap.w	d2
	and.w	#$7FFF,d0
	beq	xtol_z			;0 or 񐳋K0
	move.w	#$3FFF+31,d2
	sub.w	d0,d2
	bcs	xtol_e			;I[o[t[
	cmp.w	#31,d2
	bhi	xtol_z			;A_[t[0
	lsr.l	d2,d1			;Vtg
	bmi	xtol5
	tst.l	d2			;t
	bpl	xtol1
	neg.l	d1			;̏ꍇ
xtol1:
	move.l	d1,d0
	moveq.l	#0,d1			;ϊł
	rts

xtol5:					;2147483648`4294967297
	tst.l	d2
	bpl	xtol1			;̏ꍇ
	cmp.l	#$80000000,d1		;$80000000̏ꍇʈ
	beq	xtol1
xtol_e:					;G[
	moveq.l	#-1,d0
	moveq.l	#-1,d1
	rts

xtol_z:					;0 or A_[t[
	moveq.l	#0,d0
	moveq.l	#0,d1
	rts

;----------------------------------------------------------------
;	gxPxɕϊ
;	in :d0:d1:d2 = gxl
;	out:d0 = 
xtos::
	move.w	d0,-(sp)		;Z[u
	and.w	#$7FFF,d0
	beq	xtos_z			;0 or 񐳋K
	cmp.w	#$3FFF+$FF-$7F,d0
	bcc	xtos_ni			;NAN or }INF or I[o[t[
	sub.w	#$3FFF-$7F,d0
	bhi	xtos5			;ϊ͐KɂȂ
	beq	xtos6			;ϊ͔񐳋KɂȂ
	neg.w	d0
	cmp.w	#23,d0
	bhi	xtos_z			;񐳋K͈̔͊OȂ̂0ɂȂ
	lsr.l	d0,d1
	moveq.l	#0,d0			;񐳋K̎w0ɂȂ
	bra	xtos6

xtos5:
	add.l	d1,d1			;rbg폜
xtos6:
	btst.l	#31-23,d1		;23rbgڂŊۂ߂s
	beq	xtos_7			;(IEEERounding to Nearest,0.5͍ŉ
	add.l	#1<<(31-23),d1		; rbgɂȂ悤Ɋۂ߂̂,
	bcc	xtos_7			; ł0.5͕KɊۂ߂)
	addq.w	#1,d0
	cmp.w	#$FF,d0
	beq	xtos_i			;ۂ߂̌ʃI[o[t[
xtos_7:
	move.b	d0,d1			;wt
	ror.l	#8,d1
	lsl.w	(sp)+			;ۑĂ𒲂ׂ
	roxr.l	#1,d1			;rbgt
	move.l	d1,d0
	rts

xtos_z:					;0 or 񐳋K
	moveq.l	#0,d0			;gxł̔񐳋K0ɂȂ
	lsl.w	(sp)+			;ۑĂ𒲂ׂ
	roxr.l	#1,d0			;rbgt
	rts

xtos_ni:				;NAN or }INF or I[o[t[
	cmp.w	#$7FFF,d0
	bne	xtos_i			;I[o[t[  INF
	add.l	d1,d1
	or.l	d2,d1
	beq	xtos_i
xtos_n:
	moveq.l	#-1,d0			;NAN
	bra	xtos_i9

xtos_i:
	move.l	#$FF000000,d0		;INF
xtos_i9:
	lsl.w	(sp)+			;ۑĂ𒲂ׂ
	roxr.l	#1,d0			;rbgt
	rts

;----------------------------------------------------------------
;	gx{xɕϊ
;	in :d0:d1:d2 = gxl
;	out:d0:d1 = 
xtod::
	move.w	d0,-(sp)		;Z[u
	and.w	#$7FFF,d0
	beq	xtod_z			;0 or 񐳋K
	cmp.w	#$3FFF+$7FF-$3FF,d0
	bcc	xtod_ni			;NAN or }INF or I[o[t[
	sub.w	#$3FFF-$3FF,d0
	bhi	xtod5			;ϊ͐KɂȂ
	beq	xtod6			;ϊ͔񐳋KɂȂ

	neg.w	d0
	cmp.w	#52,d0
	bhi	xtod_z			;񐳋K͈̔͊OȂ̂0ɂȂ
	subq.w	#1,d0
xtod1:
	lsr.l	#1,d1
	roxr.l	#1,d2
	dbra	d0,xtod1
	moveq.l	#0,d0			;񐳋K̎w0ɂȂ
	bra	xtod6

xtod5:
	add.l	d2,d2			;rbg폜
	addx.l	d1,d1
xtod6:
	btst.l	#31-(52-32),d2		;52rbgڂŊۂ߂s
	beq	xtod_7			;(IEEERounding to Nearest,0.5͍ŉ
	add.l	#1<<(31-(52-32)),d2	; rbgɂȂ悤Ɋۂ߂̂,
	bcc	xtod_7			; ł0.5͕KɊۂ߂)
	addq.l	#1,d1
	bcc	xtod_7
	addq.w	#1,d0
	cmp.w	#$7FF,d0
	beq	xtod_i			;ۂ߂̌ʃI[o[t[
xtod_7:
	and.l	#$FFFFF000,d2		;svrbgNA
	or.w	d0,d2			;wt
	swap.w	d2
	swap.w	d1
	move.l	d2,d0
	move.w	d1,d0
	move.w	d2,d1

	move.l	d1,d2
	move.w	d0,d2
	rol.l	#5,d0
	rol.l	#5,d1
	rol.l	#5,d2
	and.w	#$001F,d0
	and.w	#$FFE0,d1
	or.w	d0,d1
	move.w	d2,d0

	lsl.w	(sp)+			;ۑĂ𒲂ׂ
	roxr.l	#1,d0			;rbgt
	roxr.l	#1,d1
	rts

xtod_z:					;0 or 񐳋K
	moveq.l	#0,d0			;gxł̔񐳋K0ɂȂ
	moveq.l	#0,d1
	lsl.w	(sp)+			;ۑĂ𒲂ׂ
	roxr.l	#1,d0			;rbgt
	rts

xtod_ni:				;NAN or }INF or I[o[t[
	cmp.w	#$7FFF,d0
	bne	xtod_i			;I[o[t[  INF
	add.l	d1,d1
	or.l	d2,d1
	beq	xtod_i
xtod_n:
	moveq.l	#-1,d0			;NAN
	moveq.l	#-1,d1
	bra	xtod_i9

xtod_i:
	move.l	#$FF000000,d0		;INF
	moveq.l	#0,d1
xtod_i9:
	lsl.w	(sp)+			;ۑĂ𒲂ׂ
	roxr.l	#1,d0			;rbgt
	rts

;----------------------------------------------------------------
;	gxpbNhfV}ɕϊ
;	in :d0:d1:d2 = gxl
;	out:d0:d1:d2 = 
xtop::
	link	a6,#-18
	movem.l	d3-d7/a0-a1,-(sp)
	move.w	d0,d6
	move.w	#$7FFF,d7
	and.w	d7,d6
	beq	xtop_zn			;0 or 񐳋K
	cmp.w	d7,d6
	beq	xtop_ni			;NAN or }INF
xtop1:
	move.w	d0,-(sp)		;
	move.w	d6,d0
	move.w	#4096*2,d6
	moveq.l	#0,d7
	cmp.w	#$3FFF,d0
	bcs	xtop_m			;1.0̏ꍇ

	lea.l	(decmantblp,pc),a0	;1.0ȏ̏ꍇ
	lea.l	(decexptblp,pc),a1	;1.0ȏ10.0̒lɕ␳
xtop_p1:
	move.w	(a1)+,d3		;10iwe[u琔l𓾂
	beq	xtop_man
	movem.l	(a0)+,d4-d5
	lsr.w	#1,d6
	cmp.w	d3,d0
	bcs	xtop_p1
	bhi	xtop_p3
	cmp.l	d4,d1
	bne	xtop_p2
	cmp.l	d5,d2
xtop_p2:
	bcs	xtop_p1
xtop_p3:				;e[u̒l傫Ȃ炻̋t|
	add.w	d6,d7
	move.w	(decexptblm-(decexptblp+2),a1),d3
	movem.l	(decmantblm-(decmantblp+8),a0),d4-d5
	bsr	xmul
	bra	xtop_p1

xtop_m:
	lea.l	(decmantblm,pc),a0	;1.0̏ꍇ
	lea.l	(decexptblm,pc),a1	;0.1ȏ1.0̒lɕ␳
xtop_m1:
	move.w	(a1)+,d3		;10iwe[u琔l𓾂
	beq	xtop_man0
	movem.l	(a0)+,d4-d5
	lsr.w	#1,d6
	cmp.w	d3,d0
	bhi	xtop_m1
	bcs	xtop_m3
	cmp.l	d4,d1
	bne	xtop_m2
	cmp.l	d5,d2
xtop_m2:
	bcc	xtop_m1
xtop_m3:				;e[u̒l菬Ȃ炻̋t|
	sub.w	d6,d7
	move.w	(decexptblp-(decexptblm+2),a1),d3
	movem.l	(decmantblp-(decmantblm+8),a0),d4-d5
	bsr	xmul
	bra	xtop_m1

xtop_man0:				;0.1ȏ1.0
	subq.w	#1,d7
	move.w	#$4002,d3
	move.l	#$A0000000,d4
	moveq.l	#0,d5
	bsr	xmul			;10{

xtop_man:				;1.0ȏ10.0̉10iɕϊ
	sub.w	#$3FFE,d0
	move.l	d1,d4
	clr.w	d4
	move.l	d2,d3
	move.w	d1,d3
	lsl.l	d0,d1
	lsl.l	d0,d2
	rol.l	d0,d3
	rol.l	d0,d4
	move.w	d3,d1			;lsl d0,d4:d1:d2 _̈ʒu킹
	lea.l	(-17,a6),a0
	movea.l	a0,a1
	move.b	d4,(a0)+		;10i

	moveq.l	#17-1,d0
	bra	xtop_man2

xtop_man1:
	move.b	d3,(a0)+
xtop_man2:
	moveq.l	#0,d3
	add.l	d2,d2
	addx.l	d1,d1
	addx.w	d3,d3			;lsl d3:d1:d2
	move.l	d1,d4
	move.l	d2,d5
	move.w	d3,d6
	add.l	d5,d5
	addx.l	d4,d4
	addx.w	d6,d6			;lsl d6:d4:d5
	add.l	d5,d5
	addx.l	d4,d4
	addx.w	d6,d6			;lsl d6:d4:d5
	add.l	d5,d2
	addx.l	d4,d1
	addx.w	d6,d3			;add d6:d4:d5,d3:d1:d2 (mulu #10,d3:d1:d2)
	dbra	d0,xtop_man1

	cmp.w	#-4933,d7
	bge	xtop_mrof
	move.w	d7,d0			;-4933ȉ̎wȂ񐳋K
	move.w	#-4933,d7
	add.w	#4933,d0
	moveq.l	#17-1,d2
	moveq.l	#0,d3
	cmp.w	#-17,d0
	blt	xtop_man5		;-4933-17ȉ̎wȂ0
	lea.l	(1,a0,d0.w),a1
	move.b	-(a1),d3		;BCDŉ
	moveq.l	#17,d1
	add.w	d0,d1
	bra	xtop_man4

xtop_man3:
	move.b	-(a1),-(a0)		;Vtg
xtop_man4:
	dbra	d1,xtop_man3
	move.w	d0,d2
	neg.w	d2
	subq.w	#1,d2
xtop_man5:
	clr.b	-(a0)			;ʂ0
	dbra	d2,xtop_man5
	movea.l	a6,a0
	lea.l	(-17,a6),a1

xtop_mrof:				;BCDŉʂľܓ
	cmp.w	#5,d3
	bcs	xtop_mrof3
	moveq.l	#17-1,d0
xtop_mrof1:
	move.b	-(a0),d1
	addq.b	#1,d1
	cmp.b	#9,d1
	bls	xtop_mrof2
	clr.b	(a0)
	dbra	d0,xtop_mrof1
	addq.w	#1,d7			;ľܓɂČオ肵
	subq.l	#1,a0
	movea.l	a0,a1
	moveq.l	#1,d1
xtop_mrof2:
	move.b	d1,(a0)
xtop_mrof3:				;BCDpbN
	moveq.l	#0,d0
	move.b	(a1)+,d0		;10i
	moveq.l	#16-1,d3
xtop_mrof4:
	move.l	d2,d4
	move.w	d1,d4
	lsl.l	#4,d2
	lsl.l	#4,d1
	rol.l	#4,d4
	move.w	d4,d1
	move.b	(a1)+,d4
	or.b	d4,d2
	dbra	d3,xtop_mrof4

xtop_exp:				;w쐬
	moveq.l	#0,d3
	move.w	d7,d3			;w
	bpl	xtop_exp1
	neg.w	d3			;w͕
xtop_exp1:
	lsl.w	#4,d0
	divu.w	#1000,d3		;1000̈ʂ𓾂
	or.w	d3,d0
	ror.w	#4,d0
	swap.w	d0
	clr.w	d3
	swap.w	d3
	divu.w	#100,d3			;100̈ʂ𓾂
	or.w	d3,d0
	rol.w	#4,d0
	clr.w	d3
	swap.w	d3
	divu.w	#10,d3			;10̈ʂ𓾂
	or.w	d3,d0
	rol.w	#4,d0
	swap.w	d3
	or.w	d3,d0			;1̈
	tst.w	d7
	bpl	xtop_exp2
	or.w	#$4000,d0		;w͕
xtop_exp2:
	tst.w	(sp)+
	bpl	xtop_exp3
	or.w	#$8000,d0		;͕
xtop_exp3:
	swap.w	d0
	movem.l	(sp)+,d3-d7/a0-a1
	unlk	a6
	rts

xtop_zn:				;0 or 񐳋K
	move.l	d1,d7
	or.l	d2,d7
	bne	xtop1
xtop_z:					;0̏ꍇ
	swap.w	d0
	clr.w	d0
	movem.l	(sp)+,d3-d7/a0-a1
	unlk	a6
	rts

xtop_ni:				;NAN or }INF
	add.l	d1,d1
	or.l	d2,d1
	bne	xtop_n			;0łȂȂNAN
xtop_i:					;INF
	swap.w	d0
	clr.w	d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	movem.l	(sp)+,d3-d7/a0-a1
	unlk	a6
	rts

xtop_n:					;NAN
	swap.w	d0
	clr.w	d0
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	movem.l	(sp)+,d3-d7/a0-a1
	unlk	a6
	rts

;----------------------------------------------------------------
;	10iwϊpe[u
decmantblp:
	.dc.l	$C4605202,$8A20979B	;10^4096
	.dc.l	$9E8B3B5D,$C53D5DE5	;10^2048
	.dc.l	$C9767586,$81750C17	;10^1024
	.dc.l	$E319A0AE,$A60E91C7	;10^512
	.dc.l	$AA7EEBFB,$9DF9DE8E	;10^256
	.dc.l	$93BA47C9,$80E98CE0	;10^128
	.dc.l	$C2781F49,$FFCFA6D5	;10^64
	.dc.l	$9DC5ADA8,$2B70B59E	;10^32
	.dc.l	$8E1BC9BF,$04000000	;10^16
	.dc.l	$BEBC2000,$00000000	;10^8
	.dc.l	$9C400000,$00000000	;10^4
	.dc.l	$C8000000,$00000000	;10^2
	.dc.l	$A0000000,$00000000	;10^1

decexptblp:
	.dc.w	$7525			;10^4096
	.dc.w	$5A92			;10^2048
	.dc.w	$4D48			;10^1024
	.dc.w	$46A3			;10^512
	.dc.w	$4351			;10^256
	.dc.w	$41A8			;10^128
	.dc.w	$40D3			;10^64
	.dc.w	$4069			;10^32
	.dc.w	$4034			;10^16
	.dc.w	$4019			;10^8
	.dc.w	$400C			;10^4
	.dc.w	$4005			;10^2
	.dc.w	$4002			;10^1
	.dc.w	0

decmantblm:
	.dc.l	$A6DD04C8,$D2CE9FDE	;10^-4096
	.dc.l	$CEAE534F,$34362DE4	;10^-2048
	.dc.l	$A2A682A5,$DA57C0BE	;10^-1024
	.dc.l	$9049EE32,$DB23D21C	;10^-512
	.dc.l	$C0314325,$637A193A	;10^-256
	.dc.l	$DDD0467C,$64BCE4A0	;10^-128
	.dc.l	$A87FEA27,$A539E9A5	;10^-64
	.dc.l	$CFB11EAD,$453994BA	;10^-32
	.dc.l	$E69594BE,$C44DE15B	;10^-16
	.dc.l	$ABCC7711,$8461CEFD	;10^-8
	.dc.l	$D1B71758,$E219652C	;10^-4
	.dc.l	$A3D70A3D,$70A3D70A	;10^-2
	.dc.l	$CCCCCCCC,$CCCCCCCD	;10^-1

decexptblm:
	.dc.w	$0AD8			;10^-4096
	.dc.w	$256B			;10^-2048
	.dc.w	$32B5			;10^-1024
	.dc.w	$395A			;10^-512
	.dc.w	$3CAC			;10^-256
	.dc.w	$3E55			;10^-128
	.dc.w	$3F2A			;10^-64
	.dc.w	$3F94			;10^-32
	.dc.w	$3FC9			;10^-16
	.dc.w	$3FE4			;10^-8
	.dc.w	$3FF1			;10^-4
	.dc.w	$3FF8			;10^-2
	.dc.w	$3FFB			;10^-1
	.dc.w	0


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: fexpr.s,v $
;	Revision 1.8  1999 10/ 6(Wed) 14:54:26 M.Kamada
;	+86 _܂ގ+gȂ
;	+86 _܂ގŉZƌZtɂȂĂ
;
;	Revision 1.7  1999  6/ 9(Wed) 22:51:03 M.Kamada
;	+85 Zq.notb./.notw.ǉ
;	+85 _܂ގŒPZqgȂ
;
;	Revision 1.6  1999  3/15(Mon) 02:21:03 M.Kamada
;	+83 _܂ގŔrƐ̉Zqg悤ɂ
;
;	Revision 1.5  1999  2/28(Sun) 20:08:46 M.Kamada
;	+82 G[bZ[W{ꉻ
;
;	Revision 1.4  1999  2/27(Sat) 23:41:11 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.3  1997 10/28(Tue) 16:44:21 M.Kamada
;	+52 PMOVE.D #imm,CRPAZułȂs
;	+52 .DC.X 0.0+$FFFF9999C00E00009999FFFF00000000ɂȂs
;	+52 _̃TCYw\ɂ
;	+52 .E+10_ƔfȂs
;
;	Revision 1.2  1997  6/24(Tue) 22:01:51 M.Kamada
;	+34 vft@CV{ɑΉ
;
;	Revision 1.1  1994/02/16  16:25:10  nakamura
;	Initial revision
;
;
